deferred class CHILDREN
feature
    children : LINKED_LIST[NODE] is
    deferred
    end

    --XXX:consider special cases?
    put_children(c : like children) is
    local
	it : ITERATOR[NODE]
    do
	children := c
	it := c.get_new_iterator
	from it.start
	until it.is_off
	loop
	    it.item.put_parent(Current)
	    it.next
	end
    end

    --adding/putting children: there are two special cases
    --cluster children with empty attributes are destroyed
    --(and their children are added)
    --two adjacent CLUSTER_TEXT's
    --are automatically merged
    put_child(c : NODE; i : INTEGER) is
    do
	--doesn't check for special cases
	children.put(c, i)
	c.put_parent(Current)
    end

    add_child(c : NODE; i : INTEGER) is
    do
	--doesn't check for special cases
	children.add(c, i)
	c.put_parent(Current)
    end

    add_last_child(c : NODE) is
    --require
	-- c /= Void
    local
	cl : CLUSTER
    do
	cl ?= c
	if cl /= Void and then cl.attribute_is_empty then
	    append_children(cl.children)
	elseif children.is_empty or else not
		try_merge_text(children.last, c) then
	    children.add_last(c)
	    c.put_parent(Current)
	end
    end

    try_merge_text(c1, c2 : NODE) : BOOLEAN is
    local
	ct1, ct2 : CLUSTER_TEXT
    do
	ct1 ?= c1
	if ct1 /= Void then
	    ct2 ?= c2
	    if ct2 /= Void then
		ct1.text.append(ct2.text)
		Result := true
	    end
	end
    end

    add_first_child(c : NODE) is
    local
	cl : CLUSTER
    do
	cl ?= c
	if cl /= Void and then cl.attribute_is_empty then
	    prepend_children(cl.children)
	elseif not children.is_empty and then
		try_merge_text(c, children.first) then
	    children.remove_first
	    add_first_child(c)
	else
	    children.add_first(c)
	    c.put_parent(Current)
	end
    end

    append_children(others : like children) is
    local
	it : ITERATOR[NODE]
    do
	it := others.get_new_iterator
	from it.start
	until it.is_off
	loop
	    add_last_child(it.item)
	    it.next
	end
    end

    prepend_children(others : like children) is
    do
	from
	until others.is_empty
	loop
	    add_first_child(others.last)
	    others.remove_last
	end
    end

    fix_bad_child(index : INTEGER) is
	--get rid of empty attributed cluster at index
    local
	i : INTEGER
	cl : CLUSTER
	it : ITERATOR[NODE]
    do
	i := index
	cl ?= children @ i
	if cl /= Void and then cl.attribute_is_empty then
	    children.remove(i)
	    it := cl.children.get_new_iterator
	    from it.start
	    until it.is_off
	    loop
		it.item.put_parent(Current)
		children.add(it.item, i)
		i := i + 1
		it.next
	    end
	else
std_error.put_string("BUG!%N")
	end
    end

    empty_count : INTEGER is
    local
	it : ITERATOR[NODE]
	cl : CLUSTER
    do
	if attribute_is_empty then
	    Result := Result + 1
	end
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    cl ?= it.item
	    if cl /= Void then
		Result := Result + cl.empty_count
	    end
	    it.next
	end
    end
end
