class CLUSTER
inherit
    NODE
	redefine
	    to_cluster
	end
    CHILDREN;
    MERGE_CHILDREN;
    TAG_SINGLETON
creation make
feature
    children : LINKED_LIST[NODE]

    cf_memo : MEMO[BOOLEAN] is
    once
	!!Result
    end

    change_flag : BOOLEAN is
    do
	Result := cf_memo.item
    end

    clear_change_flag is
    do
	cf_memo.set_item(false)
    end
    set_change_flag is
    do
	cf_memo.set_item(true)
    end

    to_cluster : CLUSTER is
    do
	Result := Current
    end

    show_info is
    local
	it : ITERATOR[NODE]
	i : INTEGER
	first : BOOLEAN
    do
	if pl_flag then
	    std_error.put_string("PL")
	end
	if em_flag then
	    std_error.put_string("EM")
	end
	if b_flag then
	    std_error.put_string("B")
	end
	if i_flag then
	    std_error.put_string("I")
	end
	if tt_flag then
	    std_error.put_string("TT")
	end
	if s_flag then
	    std_error.put_string("S")
	end

	from i := 1
	until i > u_count
	loop
	    std_error.put_string("U")
	    i := i + 1
	end

	if color /= Void then
	    std_error.put_string(color.name)
	end
	if size /= Void then
	    std_error.put_string(size.name)
	end
	std_error.put_string("(")
	first := true
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    if first then
		first := false
	    else
		std_error.put_string(", ")
	    end
	    it.item.show_info
	    it.next
	end
	std_error.put_string(")")
    end

    make is
    do
	!!children.make
    end

    put_size_color(t1, t2 : TAG) is
    do
	size := t1
	color := t2
    end

    put_bisemttplusc(b, i, s, em, tt, pl : BOOLEAN; u : INTEGER; t1, t2 : TAG) is
    do
	b_flag := b
	i_flag := i
	s_flag := s
	em_flag := em
	tt_flag := tt
	pl_flag := pl
	u_count := u
	size := t1
	color := t2
    end

    color : TAG
    size : TAG
    pl_flag : BOOLEAN
    s_flag : BOOLEAN
    em_flag : BOOLEAN
    tt_flag : BOOLEAN
    b_flag : BOOLEAN
    i_flag : BOOLEAN
    u_count : INTEGER

    --I'll write these on demand
    set_s_flag is
    do
	s_flag := true
    end

    clear_s_flag is
    do
	s_flag := false
    end

    set_em_flag is
    do
	em_flag := true
    end

    clear_em_flag is
    do
	em_flag := false
    end

    put_color(tag : TAG) is
    do
	color := tag
    end

    put_size(tag : TAG) is
    do
	size := tag
    end

    init_with_tags(tl : LINKED_LIST[TAG_HOLDER]) is
    local
	tag : TAG
    do
	from
	until tl.is_empty
	loop
	    tag := tl.last.tag
	    if is_start_color_tag(tag) then
		if color = Void then
		    color := tag
		end
	    elseif is_start_size_tag(tag) then
		if size = Void then
		    size := tag
		end
	    elseif not pl_flag then
		if tag = pl_tag then
		    pl_flag := true
		elseif tag = s_tag then
		    s_flag := true
		    em_flag := false
		elseif tag = em_tag then
		    if not s_flag then
			em_flag := not em_flag
		    end
		elseif tag = b_tag then
		    b_flag := true
		elseif tag = i_tag then
		    i_flag := true
		elseif tag = tt_tag then
		    tt_flag := true
		elseif tag = u_tag then
		    u_count := u_count + 1
		end
	    else
		--can safely ignore tag; it's shadowed
	    end
	    tl.remove_last
	end
    end

    --gotta think of a better way to do this stuff
    output is
	--order is important for some of these tags
    local
	it : ITERATOR[NODE]
	i : INTEGER
    do
	if color /= Void then
	    io.put_string("<")
	    io.put_string(color.name)
	    io.put_string(">")
	end
	if size /= Void then
	    io.put_string("<")
	    io.put_string(size.name)
	    io.put_string(">")
	end
	if pl_flag then
	    io.put_string("<PL>")
	end
	if em_flag then
	    io.put_string("<EM>")
	end
	if s_flag then
	    io.put_string("<S>")
	end
	if b_flag then
	    io.put_string("<B>")
	end
	if i_flag then
	    io.put_string("<I>")
	end
	if tt_flag then
	    io.put_string("<TT>")
	end

	from i := 1
	until i > u_count
	loop
	    io.put_string("<U>")
	    i := i + 1
	end

	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    it.item.output
	    it.next
	end
	from i := 1
	until i > u_count
	loop
	    io.put_string("</U>")
	    i := i + 1
	end
	if tt_flag then
	    io.put_string("</TT>")
	end
	if i_flag then
	    io.put_string("</I>")
	end
	if b_flag then
	    io.put_string("</B>")
	end
	if s_flag then
	    io.put_string("</S>")
	end
	if em_flag then
	    io.put_string("</EM>")
	end
	if pl_flag then
	    io.put_string("</PL>")
	end
	if size /= Void then
	    io.put_string("</")
	    io.put_string(size.name)
	    io.put_string(">")
	end
	if color /= Void then
	    io.put_string("</")
	    io.put_string(color.name)
	    io.put_string(">")
	end
    end

    cost : INTEGER is
    do
	if pl_flag then Result := Result + 9 end
	if em_flag then Result := Result + 9 end
	if tt_flag then Result := Result + 9 end
	if b_flag then Result := Result + 7 end
	if i_flag then Result := Result + 7 end
	if s_flag then Result := Result + 7 end
	if color /= Void then Result := Result + 7 end
	if size /= Void then Result := Result + 7 end
	Result := Result + 7 * u_count
    end

    common_cluster(other : like Current) : like Current is
    local
	common_size : TAG
	common_color : TAG
    do
	--here we go again <sigh>
	if size = other.size then common_size := size end
	if color = other.color then common_color := color end
	!!Result.make
	if pl_flag /= other.pl_flag then
	    Result.put_size_color(common_size, common_color)
	else
	    Result.put_bisemttplusc(
		b_flag and other.b_flag,
		i_flag and other.i_flag,
		s_flag and other.s_flag,
		em_flag and other.em_flag,
		tt_flag and other.tt_flag,
		pl_flag, --pl_flag and other.pl_flag,
		u_count.min(other.u_count),
		common_size,
		common_color)
	end
    end

    attribute_is_empty : BOOLEAN is
    do
	Result := not b_flag
	and then not i_flag
	and then not s_flag
	and then not em_flag
	and then not tt_flag
	and then not pl_flag
	and then u_count = 0
	and then color = Void
	and then size = Void
    end

    subtract(other : like Current) is
    --require
	--greater_than(other)
    do
	if other.b_flag then b_flag := false end
	if other.i_flag then i_flag := false end
	if other.s_flag then s_flag := false end
	if other.em_flag then em_flag := false end
	if other.tt_flag then tt_flag := false end
	if other.pl_flag then pl_flag := false end
	u_count := u_count - other.u_count
	if other.color /= Void then color := Void end
	if other.size /= Void then size := Void end
    end

    assign(other : like Current) is
    do
	b_flag := other.b_flag
	i_flag := other.i_flag
	s_flag := other.s_flag
	em_flag := other.em_flag
	tt_flag := other.tt_flag
	pl_flag := other.pl_flag
	u_count := other.u_count
	color := other.color
	size := other.size
    end

    commute(other : like Current) : BOOLEAN is
    do
	Result := pl_flag = other.pl_flag
	and then (color = other.color
		or else color = Void or else other.color = Void)
	and then (size = other.size
		or else size = Void or else other.size = Void)
	if Result then
	    if (em_flag and other.s_flag) or (s_flag and other.em_flag) then
		Result := false
	    end
	end
    end

    overlap_invert_optimize is
    local
	cl : CLUSTER
	it : ITERATOR[NODE]
    do
	overlap_invert_children
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    cl ?= it.item
	    if cl /= Void then cl.overlap_invert_optimize end
	    it.next
	end
    end

    overlap_invert_children is
    --require
	--absorption impossbile
    local
	i : INTEGER
	cl, last_cl : CLUSTER
    do
--std_error.put_string("%Nd1: ")
--show_info
	from i := children.lower
	until i > children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void and then last_cl /= Void
		    and then cl.commute(last_cl) then
--std_error.put_string("%Nlastcl: ")
--last_cl.show_info
--std_error.put_string("%Ncl: ")
--cl.show_info
		if invert1_saving(last_cl, cl) > 0 then
		    do_invert1_and_absorb_check(i - 1)
		elseif invert2_saving(last_cl, cl) > 0 then
		    do_invert2_and_absorb_check(i - 1)
		end
	    end
	    last_cl := cl
	    i := i + 1
	end
    end

    attribute_equal(other : like Current) : BOOLEAN is
    do
	Result := b_flag = other.b_flag
	and then i_flag = other.i_flag
	and then s_flag = other.s_flag
	and then em_flag = other.em_flag
	and then tt_flag = other.tt_flag
	and then pl_flag = other.pl_flag
	and then u_count = other.u_count
	and then color = other.color
	and then size = other.size
    end

    invert1_saving(c1, c2 : CLUSTER) : INTEGER is
    local
	cl : CLUSTER
    do
--std_error.put_string("%Nthusfarcl: ")
	cl ?= c1.children.last
	if cl /= Void and then cl.attribute_equal(c2) then
--cl.show_info
	    Result := c2.cost - c1.cost
	end
    end

    invert2_saving(c1, c2 : CLUSTER) : INTEGER is
    local
	cl : CLUSTER
    do
	cl ?= c2.children.first
	if cl /= Void and then cl.attribute_equal(c1) then
	    Result := c1.cost - c2.cost
	end
    end

    do_invert1_and_absorb_check(i : INTEGER) is
    local
	c1, c2, cl, cnew : CLUSTER
	ignore : BOOLEAN
    do
	c1 ?= children @ i
	c2 ?= children @ (i + 1)
	cl ?= c1.children.last
	c1.children.remove_last
	!!cnew.make
	cnew.assign(c1)
	--btw c1.children can't be empty otherwise it would've been absorbed
	--important: can only attempt absorption after assignment
	ignore := c1.try_absorb
	cnew.put_children(cl.children)
	c2.add_first_child(cnew)
	set_change_flag
    end

    do_invert2_and_absorb_check(i : INTEGER) is
    local
	c1, c2, cl, cnew : CLUSTER
	ignore : BOOLEAN
    do
	c1 ?= children @ i
	c2 ?= children @ (i + 1)
	cl ?= c2.children.first
	c2.children.remove_first
	!!cnew.make
	cnew.assign(c2)
	--btw c2.children can't be empty otherwise it would've been absorbed
	--important: can only attempt absorption after assignment
	ignore := c2.try_absorb
	cnew.put_children(cl.children)
	c1.add_last_child(cnew)
	set_change_flag
    end

    emsem_optimize is
    local
	it : ITERATOR[NODE]
	cl : CLUSTER
    do
	emsem_children_and_absorb
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    cl ?= it.item
	    if cl /= Void then
		cl.emsem_optimize
	    end
	    it.next
	end
    end

    emsem_children_and_absorb is
    local
	i : INTEGER
	c1, c2, c3, cnew : CLUSTER
	ignore : BOOLEAN
    do
	i := children.lower
	from
	until i > children.upper - 2
	loop
	    c1 ?= children @ i
	    if c1 /= Void and then c1.em_flag and then not c1.pl_flag then
		c2 ?= children @ (i + 1)
		if c2 /= Void and then c2.s_flag then
		    --c2 can be PL'ed if it wants
		    c3 ?= children @ (i + 2)
		    if c3 /= Void and then c3.em_flag and then not c3.pl_flag then
			--we have an emsem
			!!cnew.make
			cnew.set_em_flag
			c1.clear_em_flag
			c3.clear_em_flag
			cnew.add_last_child(c1)
			cnew.add_last_child(c2)
			cnew.add_last_child(c3)
			children.remove(i)
			children.remove(i)
			put_child(cnew, i)
			set_change_flag
			--we may be part of a bigger emsem so recheck this one
			i := i - 1
		    end
		end
	    end
	    i := i + 1
	end
	ignore := try_absorb
    end

    absorb_optimize is
	--try not to use; instead absorb automatically in other places
    local
	cl : CLUSTER
	i : INTEGER
    do
	from
	until not try_absorb
	loop
--std_error.put_string("absorbed.%N")
	end

	from i := children.lower
	until i > children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void then
		cl.absorb_optimize
	    end
	    i := i + 1
	end
    end

    try_absorb : BOOLEAN is
    local
	cl : CLUSTER
    do
	--exactly one child, and it's a cluster?
	if children.count = 1 then
	    cl ?= children.first
	    if cl /= Void then
		attribute_absorb(cl)
		put_children(cl.children)
		Result := true
		--complication: suppose absorbing means we're empty
		--then we might be able to merge texts
		--only the root window could be empty, but
		--<EM>'s can be cancelled!
		--if attribute_is_empty and then parent /= Void then
		    --these things screw up the algorithms
		    --fix these afterwards by careful coding
		--end
	    end
	end
    end

    attribute_absorb(other : like Current) is
    do
	if other.color /= Void then
	    color := other.color
	end
	if other.size /= Void then
	    size := other.size
	end
	if other.pl_flag then
	    b_flag := other.b_flag
	    i_flag := other.i_flag
	    s_flag := other.s_flag
	    em_flag := other.em_flag
	    tt_flag := other.tt_flag
	    pl_flag := other.pl_flag
	    u_count := other.u_count
	else
	    if other.b_flag then b_flag := true end
	    if other.i_flag then i_flag := true end
	    if other.tt_flag then tt_flag := true end
	    --at most one of the following two can happen
	    if other.em_flag then
		em_flag := not em_flag
	    end
	    if other.s_flag then
		s_flag := true
		em_flag := false
	    end
	    u_count := u_count + other.u_count
	    if u_count > 3 then
		u_count := 3
	    end
	end
    end

    sctoggle : BOOLEAN

    sctuple(cl : CLUSTER) : TAG is
    do
	if sctoggle then
	    Result := cl.size
	else
	    Result := cl.color
	end
    end

    put_sctuple(cl : CLUSTER; tag : TAG) is
    do
	if sctoggle then
	    cl.put_size(tag)
	else
	    cl.put_color(tag)
	end
    end

    color_nest_optimize is
	--try to call this after a merge
    do
	sctoggle := false
	scnest_optimize
    end

    size_nest_optimize is
	--try to call this after a merge
    do
	sctoggle := true
	scnest_optimize
    end

    scnest_optimize is
	--try to call this after a merge
    local
	it : ITERATOR[NODE]
	cl : CLUSTER
    do
	scnest_children
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    cl ?= it.item
	    if cl /= Void then
		cl.scnest_optimize
	    end
	    it.next
	end
    end

    scnest_children is
    local
	i, j : INTEGER
	cl : CLUSTER
	done : BOOLEAN
    do
	from i := children.lower
	until i > children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void and then sctuple(cl) /= Void then
		j := i + 1
		done := false
		from
		until done
		loop
		    if j > children.upper then
			done := true
		    else
			cl ?= children @ j
			if cl /= Void and then sctuple(cl) /= Void then
			    j := j + 1
			else
			    done := true
			end
		    end
		end
		if j <= i + 2 or else not search_scnest(i, j - 1) then
		    i := j
		end
	    else
		i := i + 1
	    end
	end
    end

    search_scnest(i1, i2 : INTEGER) : BOOLEAN is
    --require
	--i1 < i2
    local
	cl : CLUSTER
	i, j : INTEGER
	done : BOOLEAN
	match_array : ARRAY[INTEGER]
    do
--if sctoggle then
--std_error.put_string("size request ")
--else
--std_error.put_string("color request ")
--end
--std_error.put_integer(i1)
--std_error.put_string(" to ")
--std_error.put_integer(i2)
--std_error.put_string("%N")
	--simple: find any match and nest those
	!!match_array.make(0, 10)
	match_array.set_all_with(-1)
	from i := i1
	until done
	loop
	    cl ?= children @ i
	    j := sctuple(cl).code
	    if match_array @ j /= -1 then
		do_scnest_and_absorb(match_array @ j, i)
		Result := true
		done := true
	    else
		match_array.put(i, j)
		i := i + 1
		if i > i2 then
		    done := true
		end
	    end
	end
    end

    extract_size_color(c1, c2 : CLUSTER) : CLUSTER is
    do
	!!Result.make
	if c1.color = c2.color then
	    Result.put_color(c1.color)
	    c1.put_color(Void)
	    c2.put_color(Void)
	end
	if c1.size = c2.size then
	    Result.put_size(c1.size)
	    c1.put_size(Void)
	    c2.put_size(Void)
	end
    end

    do_scnest_and_absorb(i1, i2 : INTEGER) is
    --require
	--i1 < i2
    local
	c1, c2, cnew : CLUSTER
	i : INTEGER
	ignore : BOOLEAN
    do
	c1 ?= children @ i1
	c2 ?= children @ i2
	cnew := extract_size_color(c1, c2)
	--i2 - i1 * remove(i1)
	from i := i1
	until i > i2
	loop
	    cnew.add_last_child(children @ i1)
	    children.remove(i1)
	    i := i + 1
	end
	add_child(cnew, i1)
	ignore := try_absorb
	set_change_flag
    end

    pl_shortcut_optimize is
	--try to call this after a merge
    local
	it : ITERATOR[NODE]
	cl : CLUSTER
    do
	pl_shortcut_children_and_absorb
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    cl ?= it.item
	    if cl /= Void then
		cl.pl_shortcut_optimize
	    end
	    it.next
	end
    end

    pl_shortcut_children_and_absorb is
    local
	i : INTEGER
	cl : CLUSTER
	ct : CLUSTER_TEXT
	ignore : BOOLEAN
    do
	from i := children.lower + 1
	until i >= children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void then
		if try_pl_shortcut_case2(i) then
		    --compensate for losing current child
		    i := i - 1
		end
	    else
		ct ?= children @ i
		if try_pl_shortcut(i) then
		    --compensate for losing current child
		    i := i - 1
		end
	    end
	    i := i + 1
	end
	ignore := try_absorb
    end

    try_pl_shortcut(i : INTEGER) : BOOLEAN is
    local
	c1, c2 : CLUSTER
	ct : CLUSTER_TEXT
    do
	c1 ?= children @ (i - 1)
	ct ?= children @ i
	c2 ?= children @ (i + 1)
	if c1 /= Void and then c2 /= Void then
	    pl_common_cluster(ct, c1, c2)
	    if pl_outer_cover.cost > pl_inner_cover.cost then
		--worth doing
		do_pl_shortcut(ct, c1, c2, i - 1)
	    end
	end
    end

    try_pl_shortcut_case2(i : INTEGER) : BOOLEAN is
    local
	c1, c2 : CLUSTER
	cl : CLUSTER
	cover : CLUSTER
	ct : CLUSTER_TEXT
	done : BOOLEAN
    do
	c1 ?= children @ (i - 1)
	cl ?= children @ i
	c2 ?= children @ (i + 1)
	if c1 /= Void and then c2 /= Void then
	    if cl.children.count = 1 then
		ct ?= cl.children.first
		if ct /= Void then
		    pl_common_cluster(ct, c1, c2)
		    if pl_outer_cover.cost + cl.cost > pl_inner_cover.cost then
			--worth doing
			do_pl_shortcut(ct, c1, c2, i - 1)
			done := true
		    end
		end
	    end
	    if not done and then cl.pl_flag then
		-- can do another trick
		--cl should already match the context
		cover := c1.common_cluster(c2)
		cover.put_size_color(Void, Void)
		--too complicated to handle color/size here
		--will be done by nesting anyway
		if cover.cost > 0 then
		    --worth doing
		    c1.subtract(cover)
		    c2.subtract(cover)
		    cover.add_last_child(c1)
		    cover.add_last_child(cl)
		    cover.add_last_child(c2)
		    children.remove(i - 1)
		    children.remove(i - 1)
		    put_child(cover, i - 1)
		    set_change_flag
		end
	    end
	end
    end

    do_pl_shortcut(ct : CLUSTER_TEXT; c1, c2 : CLUSTER;
	    pos : INTEGER) is
    do
	c1.subtract(pl_outer_cover)
	c2.subtract(pl_outer_cover)
	pl_outer_cover.add_last_child(c1)
	pl_outer_cover.add_last_child(pl_inner_cover)
	pl_outer_cover.add_last_child(c2)
	pl_inner_cover.add_last_child(ct)
	children.remove(pos)
	children.remove(pos)
	put_child(pl_outer_cover, pos)
	set_change_flag
    end

    pl_inner_cover : CLUSTER
    pl_outer_cover : CLUSTER

    pl_common_cluster(ct : CLUSTER_TEXT; c1, c2 : like Current) is
	--special for the PL shortcut optimization
	--different pl's on either side break it
	--colors can't be saved unless c is colored
	--similarly for sizes
    local
	pc : CLUSTER
	c : CONTEXT
	common_color, common_size : TAG
    do
	!!pl_inner_cover.make
	!!pl_outer_cover.make
	c := ct.context
	pl_inner_cover.put_bisemttplusc(
		c.b_flag,
		c.i_flag,
		c.s_flag,
		c.em_flag,
		c.tt_flag,
		true,
		c.u_count,
		c.color,
		c.size)
--if pl_inner_cover.color /= c.color then
--BUG in SmallEiffel? there aren't equal!
--end

	--if the c isn't root colored then we're allowed to
	--lift common colors. Same goes for sizes
	if pl_inner_cover.color /= Void then
	    if c1.color = c2.color then
		common_color := c1.color
		if common_color = pl_inner_cover.color then
		    pl_inner_cover.put_color(Void)
		end
	    end
	end
	if pl_inner_cover.size /= Void then
	    if c1.size = c2.size then
		common_size := c1.size
		if common_size = pl_inner_cover.size then
		    pl_inner_cover.put_size(Void)
		end
	    end
	end
	if c1.pl_flag = c2.pl_flag then
	    pl_outer_cover.put_bisemttplusc(
		c1.b_flag and c2.b_flag,
		c1.i_flag and c2.i_flag,
		c1.s_flag and c2.s_flag,
		c1.em_flag and c2.em_flag,
		c1.tt_flag and c2.tt_flag,
		c1.pl_flag, --pl_flag and other.pl_flag,
		c1.u_count.min(c2.u_count),
		common_size,
		common_color)
	else
	    pl_outer_cover.put_size_color(common_size, common_color)
	end
	--one more thing; if there is no common color,
	--then the inner color might be right anyway
	--(same for sizes)
	if common_color = Void then
	    if pl_inner_cover.color /= Void then
		from pc := c1.parent
		until pc = Void or else pc.color /= Void
		loop
		    pc := pc.parent
		end
		if pc /= Void and then pc.color = pl_inner_cover.color then
		    pl_inner_cover.put_color(Void)
		end
	    end
	end
	if common_size = Void then
	    if pl_inner_cover.size /= Void then
		from pc := c1.parent
		until pc = Void or else pc.size /= Void
		loop
		    pc := pc.parent
		end
		if pc /= Void and then pc.size = pl_inner_cover.size then
		    pl_inner_cover.put_size(Void)
		end
	    end
	end
    end

    renest_optimize is
    local
	cl : CLUSTER
	it : ITERATOR[NODE]
    do
	renest_children
	it := children.get_new_iterator
	from it.start
	until it.is_off
	loop
	    cl ?= it.item
	    if cl /= Void then cl.renest_optimize end
	    it.next
	end
    end

    renest_children is
    local
	i : INTEGER
	cl : CLUSTER
    do
	from i := children.lower
	until i > children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void and then renest1(cl) then
		fix_bad_child(i)
		i := children.lower
	    else
		i := i + 1
	    end
	end

	from i := children.lower
	until i > children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void and then renest2(cl) then
		fix_bad_child(i)
		i := children.lower
	    else
		i := i + 1
	    end
	end
    end

    renest1(c1 : CLUSTER) : BOOLEAN is
    local
	c2 : CLUSTER
	cnew : CLUSTER
	n : NODE
    do
	c2 ?= c1.children.last
	if c2 /= Void then
	    cnew := extract_renestable(c1, c2)
	    if not cnew.attribute_is_empty then
		set_change_flag
		from n := c1.children.first
		until n = c2
		loop
		    cnew.add_last_child(n)
		    c1.children.remove_first
		    n := c1.children.first
		end
		cnew.ignore_try_absorb
		c1.add_first_child(cnew)
		    --takes care of any bad_child

		Result := c1.attribute_is_empty
	    end
	end
    end

    renest2(c1 : CLUSTER) : BOOLEAN is
    local
	c2 : CLUSTER
	cnew : CLUSTER
	n : NODE
    do
	c2 ?= c1.children.first
	if c2 /= Void then
	    cnew := extract_renestable(c1, c2)
	    if not cnew.attribute_is_empty then
		set_change_flag
		from n := c1.children.last
		until n = c2
		loop
		    cnew.add_first_child(n)
		    c1.children.remove_last
		    n := c1.children.last
		end
		cnew.ignore_try_absorb
		c1.add_last_child(cnew)
		    --takes care of any bad_child

		Result := c1.attribute_is_empty
	    end
	end
    end

    extract_renestable(c1, c2 : CLUSTER) : CLUSTER is
    do
	!!Result.make
	if c1.color /= Void and then c2.color /= Void then
	    Result.put_color(c1.color)
	    c1.put_color(Void)
	end
	if c1.size /= Void and then c2.size /= Void then
	    Result.put_size(c1.size)
	    c1.put_size(Void)
	end
	--following two require thought to see, especially second one
	--(think about effect of PL as well)
	if c1.em_flag and then c2.s_flag then
	    Result.set_em_flag
	    c1.clear_em_flag
	end
	if c1.s_flag and then c2.em_flag then
	    Result.set_s_flag
	    c1.clear_s_flag
	end
    end
end
