class DECOMPOSE
    --decompose into cluster tree form
inherit
    TAG_SINGLETON
creation make
feature
    make is
    do
    end

    program : TWO_WAY_LINKED_LIST[ROW]

    decompose(sml : SML) : CLUSTER is
    do
	program := sml.program
	!!Result.make
	    -- the root cluster

	rewind_pointer
	parse_cluster_body(Result)
    end

feature {NONE}

    row_pointer : ITERATOR[ROW]
    tag_pointer : ITERATOR[TAG_HOLDER]

    rewind_pointer is
    do
	row_pointer := program.get_new_iterator
	row_pointer.start
	tag_pointer := row_pointer.item.tag_list.get_new_iterator
	tag_pointer.start
	end_of_program := false
    end

    end_of_program : BOOLEAN

    advance_pointer is
    --require
	--not end_of_program
    do
	if tag_pointer.is_off then
	    row_pointer.next
	    if row_pointer.is_off then
		end_of_program := true
	    else
		tag_pointer := row_pointer.item.tag_list.get_new_iterator
		tag_pointer.start
	    end
	else
	    tag_pointer.next
	end
    end

    at_end : BOOLEAN is
    do
	if close_start_tag = Void then
	    Result := end_of_program
	elseif not tag_pointer.is_off then
	    if tag_pointer.item = close_start_tag then
		Result := true
		from
		until tag_pointer.item = close_end_tag
		loop
		    tag_pointer.next
		end
	    end
	end
    end
    
    parse_cluster_body(cluster : CLUSTER) is
    local
	cltext : CLUSTER_TEXT
	row : ROW
    do
	from
	until at_end
	loop
	    if tag_pointer.is_off then
		--we have text
		row := row_pointer.item
		if not row.text.is_empty then
		    !!cltext.make(row.context, row.text)
		    cluster.add_last_child(cltext)
		end
	    else
		parse_cluster(cluster, tag_pointer.item)
	    end
	    advance_pointer
	end
    end

    close_start_tag : TAG_HOLDER
    close_end_tag : TAG_HOLDER

    parse_cluster(cluster : CLUSTER; th : TAG_HOLDER) is
    local
	cl : CLUSTER
	tl : LINKED_LIST[TAG_HOLDER]
	save_close_start_tag : TAG_HOLDER
	save_close_end_tag : TAG_HOLDER
    do
	!!cl.make
	tl := get_cluster(th)
	save_close_start_tag := close_start_tag
	save_close_end_tag := close_end_tag
	close_start_tag := tl.last.partner
	close_end_tag := tl.first.partner
	from
	until tag_pointer.item = tl.last
	loop
	    tag_pointer.next
	end
	tag_pointer.next
	parse_cluster_body(cl)
	close_start_tag := save_close_start_tag
	close_end_tag := save_close_end_tag
	cl.init_with_tags(tl)
	cluster.add_last_child(cl)
    end

    get_cluster(th : TAG_HOLDER) : LINKED_LIST[TAG_HOLDER] is
    local
	i : INTEGER
	tl : LINKED_LIST[TAG_HOLDER]
	done : BOOLEAN
	index : INTEGER
    do
	tl := th.row.tag_list
	index := tl.fast_index_of(th)
	!!Result.make
	Result.add_last(th)
	from i := index + 1
	until done
	loop
	    if i > tl.upper then
		done := true
	    else
		if tl.item(i).partner.row = th.partner.row then
		    Result.add_last(tl @ i)
		    i := i + 1
		else
		    done := true
		end
	    end
	end
    end
end
