deferred class MERGE_CHILDREN
inherit OPTIMIZER
feature
    --can call this instead of using the visitor
    merge_optimize : BOOLEAN is
    local
	cl : CLUSTER
	i : INTEGER
    do
	from
	until not merge_children
	loop
	end

	from i := children.lower
	until i > children.upper
	loop
	    cl ?= children @ i
	    if cl /= Void and then cl.merge_optimize then
		fix_bad_child(i)
		i := children.lower
	    else
		i := i + 1
	    end
	end
	Result := attribute_is_empty
    end

    merge_children : BOOLEAN is
	--tries to merge children
	--returns true if successful
    local
	i, j : INTEGER
	last_cl : CLUSTER
	cl : CLUSTER
	max_saving : INTEGER
	max_i : INTEGER
	done : BOOLEAN
    do
	--examine every pair of adjacent child clusters
	--out of adjacent mergers, pick the best one (greedy)
	max_saving := 0
	from i := children.lower
	until i > children.upper or done
	loop
	    cl ?= (children @ i)
	    if cl = Void then
		if max_saving > 0 then
		    done := true
		end
	    elseif last_cl /= Void then
		j := merge_saving(last_cl, cl)
		if j > max_saving then
		    max_saving := j
		    max_i := i-1
		end
	    end
	    if not done then
		last_cl := cl
		i := i + 1
	    end
	end

	--do biggest merger possible
	if max_saving > 0 then
	    do_merge_and_absorb_check(max_i)
	    Result := true
	end
    end

    merge_saving(c1, c2 : CLUSTER) : INTEGER is
    do
	Result := c1.common_cluster(c2).cost
    end

    do_merge_and_absorb_check(i : INTEGER) is
    local
	c1, c2 : CLUSTER
	cl : CLUSTER
    do
	--bad style
	c1 ?= children @ i
	children.remove(i)
	c2 ?= children @ i
	cl := c1.common_cluster(c2)
	c1.subtract(cl)
	c2.subtract(cl)
	cl.add_last_child(c1)
	cl.add_last_child(c2)
	--try absorptions:
	--c1 and c2 may both be attribute_is_empty
	--add_last_child should automatically fix bad children

	--thus cl could absorb them
	--I don't think this can ever end up empty
	cl.ignore_try_absorb
	put_child(cl, i)

	--we lost a child, so we may be able to absorb
	ignore_try_absorb
	set_change_flag
    end

    ignore_try_absorb is
    local
	ignore : BOOLEAN
    do
	ignore := try_absorb
    end
end
