deferred class REMOVE_TAGS
    --remove tags that open and close on the same line
inherit
    SML_HELPER
feature
    remove_tags is
	--eliminate sequences like <B><1></1></B>
	--also handle multiple <EM>'s
    local
	i : INTEGER
	row : ROW
	last_row : ROW
	    --holds last nonempty row or Void
    do
	--a little messy because we get rid of rows with
	--empty tag_lists at the same time
	last_row := Void
	from  i := program.lower
	until i > program.upper
	loop
	    row := program @ i
	    remove_tag_list(row)
	    if row.tag_list.is_empty and then last_row /= Void then
		last_row.text.append(row.text)
		program.remove(i)
	    else
		last_row := row
		i := i + 1
	    end
	end
    end
    
    remove_tag_list(row : ROW) is
	--return true if tag_list ends up empty
	--get rid of <B></B> et. al
    local
	t, p : TAG_HOLDER
	list : LINKED_LIST[TAG_HOLDER]

	i, j : INTEGER
    do
	--get rid of open/close pairs on this row
	list := row.tag_list
	from i := list.lower
	until i > list.upper
	loop
	    t := list @ i
	    p := t.partner
	    --eliminate same row open/close pairs
	    if p.row = row then
		from j := i + 1
		until list.item(j) = p
		loop
		    j := j + 1
		end
		list.remove(j) --remove later elements first
		list.remove(i) --to avoid screwing up numbering
	    else
		i := i + 1
	    end
	end
    end
end
